
package xyz.brassgoggledcoders.boilerplate.lib.common.items;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;
import xyz.brassgoggledcoders.boilerplate.lib.client.utils.GuiColors;

import java.util.List;

/**
 * @author warlordjones
 *
 */
public class BaseElectricStorageItem extends BaseElectricItem
{
	public BaseElectricStorageItem(String texturePath, String name, int maxEnergy, int maxReceive, int maxSend)
	{
		super(texturePath, name, maxEnergy, maxReceive, maxSend);
	}

	@Override
	public void func_77624_a(ItemStack stack, EntityPlayer entityplayer, List<String> list, boolean flag)
	{
		super.func_77624_a(stack, entityplayer, list, flag);
		if (this.maxSend > 0)
		{
			if ((stack.func_77978_p() != null) && stack.func_77978_p().func_74767_n("canCharge"))
			{
				list.add(GuiColors.GREEN + "Charging items in inventory...");
				list.add(GuiColors.GREEN + "Sneak + Right Click to turn off.");
			}
			else
				list.add("Sneak + Right Click to charge items in your inventory.");
		}
	}

	@Override
	public ItemStack func_77659_a(ItemStack stack, World world, EntityPlayer player)
	{
		if (player.func_70093_af() && (this.maxSend > 0))
		{
			NBTTagCompound tag = stack.func_77978_p();

			if (tag == null)
				tag = new NBTTagCompound();

			tag.func_74757_a("canCharge", !tag.func_74767_n("canCharge"));

			stack.func_77982_d(tag);
		}
		return stack;
	}

	@Override
	public void func_77663_a(ItemStack stack, World world, Entity entity, int par4, boolean par5)
	{
		if (entity instanceof EntityPlayer)
		{
			NBTTagCompound tag = stack.func_77978_p();

			if ((tag != null) && tag.func_74767_n("canCharge"))
			{
				EntityPlayer player = (EntityPlayer) entity;
				if (this.maxSend > 0)
				{
					int energy = Math.min(this.maxSend, this.getEnergyStored(stack));
					int maxEnergy = energy;

					ItemStack[] mainInv = player.field_71071_by.field_70462_a;

					for (ItemStack element : mainInv)
						if ((element != null) && (element != stack) && (element.func_77973_b() instanceof IEnergyItem))
						{
							IEnergyItem container = (IEnergyItem) element.func_77973_b();

							energy -= container.receiveEnergy(element, energy, false);

							if (energy == 0)
								break;
						}

					if ((maxEnergy - energy) > 0)
						this.extractEnergy(stack, maxEnergy - energy, false);
				}
			}
		}
	}
}
