package xyz.brassgoggledcoders.boilerplate.lib.common.tileentities;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.IChatComponent;
import net.minecraft.world.World;
import xyz.brassgoggledcoders.boilerplate.lib.client.guis.IOpenableGUI;

/**
 * Basic machine class.Every machine that has an inventory should extend this.
 *
 * @author decebaldecebal
 *
 */
public abstract class BaseTileWithInventory extends TileEntity implements IInventory, IOpenableGUI, IOnSlotChanged
{
	public ItemStack[] inventory;

	public BaseTileWithInventory(int invSize)
	{
		this.inventory = new ItemStack[invSize];
	}

	@Override
	public void func_145839_a(NBTTagCompound tag)
	{
		super.func_145839_a(tag);

		NBTTagList nbttaglist = (NBTTagList) tag.func_74781_a("Items");
		this.inventory = new ItemStack[this.func_70302_i_()];

		for (int i = 0; i < nbttaglist.func_74745_c(); ++i)
		{
			NBTTagCompound nbttagcompound1 = nbttaglist.func_150305_b(i);
			byte b0 = nbttagcompound1.func_74771_c("Slot");

			if ((b0 >= 0) && (b0 < this.inventory.length))
			{
				this.inventory[b0] = ItemStack.func_77949_a(nbttagcompound1);
			}
		}
	}

	@Override
	public void func_145841_b(NBTTagCompound tag)
	{
		super.func_145841_b(tag);

		NBTTagList nbttaglist = new NBTTagList();

		for (int i = 0; i < this.inventory.length; ++i)
		{
			if (this.inventory[i] != null)
			{
				NBTTagCompound nbttagcompound1 = new NBTTagCompound();
				nbttagcompound1.func_74774_a("Slot", (byte) i);
				this.inventory[i].func_77955_b(nbttagcompound1);
				nbttaglist.func_74742_a(nbttagcompound1);
			}
		}

		tag.func_74782_a("Items", nbttaglist);
	}

	@Override
	public int func_70302_i_()
	{
		return this.inventory.length;
	}

	@Override
	public ItemStack func_70301_a(int par1)
	{
		return this.inventory[par1];
	}

	@Override
	public ItemStack func_70298_a(int par1, int par2)
	{
		if (this.inventory[par1] != null)
		{
			ItemStack var3;

			if (this.inventory[par1].field_77994_a <= par2)
			{
				var3 = this.inventory[par1];
				this.inventory[par1] = null;
				return var3;
			}
			else
			{
				var3 = this.inventory[par1].func_77979_a(par2);

				if (this.inventory[par1].field_77994_a == 0)
				{
					this.inventory[par1] = null;
				}

				return var3;
			}
		}
		else
		{
			return null;
		}
	}

	@Override
	public ItemStack func_70304_b(int index)
	{
		return null;
	}

	@Override
	public void func_70299_a(int par1, ItemStack par2ItemStack)
	{
		this.inventory[par1] = par2ItemStack;

		if ((par2ItemStack != null) && (par2ItemStack.field_77994_a > this.func_70297_j_()))
		{
			par2ItemStack.field_77994_a = this.func_70297_j_();
		}
	}

	@Override
	public int func_70297_j_()
	{
		return 64;
	}

	@Override
	public boolean func_70300_a(EntityPlayer player)
	{
		return (this.field_145850_b.func_175625_s(this.func_174877_v()) == this) && (player.func_174831_c(this.func_174877_v()) <= 64.0D);
	}

	@Override
	public void func_174889_b(EntityPlayer player)
	{

	}

	@Override
	public void func_174886_c(EntityPlayer player)
	{

	}

	@Override
	public boolean func_94041_b(int i, ItemStack itemstack)
	{
		return false;
	}

	@Override
	public int func_174887_a_(int id)
	{
		return 0;
	}

	@Override
	public void func_174885_b(int id, int value)
	{

	}

	@Override
	public int func_174890_g()
	{
		return 0;
	}

	@Override
	public void func_174888_l()
	{

	}

	@Override
	public void onSlotChanged(Slot slot)
	{
	}

	@Override
	public abstract Object getClientGuiElement(int ID, EntityPlayer player, World world, BlockPos blockPos);

	@Override
	public abstract Object getServerGuiElement(int ID, EntityPlayer player, World world, BlockPos blockPos);

	@Override
	public String func_70005_c_()
	{
		return "";
	}

	@Override
	public boolean func_145818_k_()
	{
		return !this.func_70005_c_().isEmpty();
	}

	@Override
	public IChatComponent func_145748_c_()
	{
		return null;
	}
}
